// javascript for Max/MSP/Jitter by samuel.freeman 2011 http://sdfphd.net
post();
post("sdf.sys.ui.polarpeek_a.js");

autowatch = 1;


var jsG = new Global("jsGlobal");


// grid units
	offsetX = 200;	// sprite 0
	offsetY = 200;	// sprite 0
	radModSize = 50;	// sprite 1
	radModOffset = 50;	// sprite 2
// MSP coefficients
	pGain = 0.;	// sprite 3
// freq Hz
	radiusModFreq = 0.;	// sprite 4
	angVelFreq = 0.;	// sprite 5
// time ms
	slew = 20.;
// text symbol
//	m_name
//	m_peekfrom






var spriteScale = 0.025;
var rgb1 = [0.95, 0.5, 0.5]; 
var rgb2 = [0.75, 0., 0.75];

var numSprites = 6;
var sprite = new Array(numSprites);
	for (i=0; i<numSprites; i++)
	{
		sprite[i] = new JitterObject("jit.gl.gridshape", "sdf_ui");
		sprite[i].scale = [spriteScale, spriteScale];
		sprite[i].poly_mode = [1,1];
		sprite[i].color = rgb1;
		sprite[i].layer = 12;
		sprite[i].enable = 0;
		sprite[i].position = [-0.7, (i/6) * -1.];
		
		if (i==0)//position sprite
		{
			sprite[i].shape = "plane";
			sprite[i].dim = [2,2] ;
			sprite[i].rotate = [45.,0.,0.,1.];
		}//end if position sprite
		else if (i==1) //radModSize sprite
		{
			sprite[i].shape = "circle";
			sprite[i].dim = [5,2] ;
		}//end if radModSize sprite
		else if (i==2) //radModOffset sprite
		{
			sprite[i].shape = "circle";
			sprite[i].dim = [6,2] ;
		}//end if radModOffset sprite
		else if (i==3) //pGain sprite
		{
			sprite[i].shape = "plane";
			sprite[i].dim = [6,2] ;
		}//end if pGain sprite
		else //freq sprites (4, and 5)
		{
			sprite[i].shape = "torus";
			sprite[i].dim = [3,24] ;
			sprite[i].rad_minor = 9/(i*i);
		}//end if freq sprite
	}//end for (i=0; i<numSprites; i++) setup

var spiroidOverlay = new JitterObject("jit.gl.gridshape", "sdf_ui");
	spiroidOverlay.scale = [1, 1];
	spiroidOverlay.poly_mode = [1,1];
	spiroidOverlay.color = [0.3,0.3,0.3];
	spiroidOverlay.layer = 12;
	spiroidOverlay.position = [-0.5, 0];
	spiroidOverlay.shape = "torus";
	spiroidOverlay.enable = 0;
	spiroidOverlay.rad_minor = 0.1;
	spiroidOverlay.dim = [13,13] ;



function showSprites(tog)
{
	for (i=0; i<numSprites; i++)
	{
		sprite[i].enable = tog;
	}//end for sprites
}//end function showSprites(tog)






var mdOnSprite = false;
jsG.bttnDownInMainArea = false;


var mdX,mdY,thisSprite,
	radModSize_x,radModSize_y,
	radModOffset_x,radModOffset_y; // these are all set in function md()

var radiusVal; // call function calcRadVal() to update this

function md(mx,my)
{
	mdX = mx;
	mdY = my;
	mdOnSprite = false; //reset
	
	jsG.bttnDownInMainArea = true; 
	
	for (i=0; i<numSprites; i++)
	{
		if( mx > sprite[i].position[0]-spriteScale) //left edge
		{	if( mx < sprite[i].position[0]+spriteScale)//right edge
			{	if( my > sprite[i].position[1]-spriteScale) //top edge
				{	if( my < sprite[i].position[1]+spriteScale) //bottom edge
					{
						mdOnSprite = true;
						thisSprite = i; //highest numbered will be got if two or more overlap
					}//end bottom edge if
				}//end top edge if
			}//end right edge if
		}//end left edge if
	}//end for (i=0; i<numSprites; i++)
	
	if (mdOnSprite)
	{
		sprite[thisSprite].color = rgb2;
		
		if(thisSprite==0)// if mouse down is on the 'position sprite'
		{ 
			// then we will need to know where the 'radModSize sprite' is:
			radModSize_x = sprite[1].position[0];
			radModSize_y = sprite[1].position[1];
			// and where the 'radModOffset sprite' is
			radModOffset_x = sprite[2].position[0];
			radModOffset_y = sprite[2].position[1];
		}// end if mouse down is on the 'position sprite'
		else if (thisSprite > 3)
		{	// if is a freq value sprite
			spiroidOverlay.enable = 1;
		}
	}//end if (mdOnSprite)
	else
	{ //if not on a sprite
		sprite[thisSprite].color = rgb1;	
	}
}//end function md(mx,my)

function mdrag(mx,my)
{
	if (mdOnSprite)
	{
		sprite[thisSprite].position = [mx,my]; // move it to where mouse is
		
		if( thisSprite == 0 ) // if this is the 'postion sprite'
		{
			// keep relative location of 'radModSize sprite' :	
				sprite[1].position = [ radModSize_x+(mx-mdX), radModSize_y+(my-mdY) ]; 
			// and of 'radModOffset sprite' :	
				sprite[2].position = [ radModOffset_x+(mx-mdX), radModOffset_y+(my-mdY) ]; 
			// output pos for matrix...	
				// scale mx my to 0.-1. range:
				mx = 0.5 * ( mx + 1.5 );
				my = 0.5 * ( (my*-1) + 1 );
				offsetX = mx*400;
				offsetY = my*400;
				outlet(0, "offsetX", offsetX);
				outlet(0, "offsetY", offsetY);
		}//end if click on 'position sprite'
		else if( thisSprite == 1 ) 
		{// if dragging the 'radModSize sprite'
			radModSize = relativeRadiusOfSprite(1)*200;
			outlet(0, "radModSize", radModSize);
		}//end if click on 'radModSize sprite'
		else if( thisSprite == 2 ) 
		{// if dragging the 'radModOffset sprite'
			radModOffset = relativeRadiusOfSprite(2)*200;
			outlet(0, "radModOffset", radModOffset);
		}//end if click on 'radModOffset sprite'
		else if( thisSprite == 3 ) 
		{// if dragging the 'pGain sprite'
			pGain = Math.max( 0., Math.min(1.,0.9*(mx+1.5)) );
			outlet(0, "pGain", pGain);
		}//end if click on 'pGain sprite'
		else
		{ // freq value sprites 
			// cartopol 
				tmpX = mx + 0.5;
				tmpY = my; 
				tmpRadius = Math.sqrt( (tmpX*tmpX)+(tmpY*tmpY) );
				// Spiroid Guide follows while dragging:
					spiroidOverlay.scale = [tmpRadius, tmpRadius];
				tmpRadius = 1. - tmpRadius; //invert across 
			// snap to Spiroid
				tmpRadius = parseInt(tmpRadius*12) * 360; // scale to octave and offset
				tmpTheta = Math.atan2(tmpY,tmpX); // gives radians ±Pi
				tmpTheta = ( tmpTheta + jsG.pi ) / jsG.pi2; // gives phase 0. to 1.
				tmpTheta *= 360;
				tmpTheta += tmpRadius; // give Spiroid Theta value in degrees
			// spiroid theta to freq Hz (inluding theta to midi, and midi offset):
				tmpFreq = mtof( (tmpTheta/30) - 24 );
			// output Freq
			if( thisSprite == 4 )
			{
				radiusModFreq = tmpFreq;
				outlet(0, "radiusModFreq", radiusModFreq);
			}
			else if( thisSprite == 5 ) 
			{
				angVelFreq = tmpFreq;
				outlet(0, "angVelFreq", angVelFreq);
			}
		}//end freq value sprites
	}//end if (mdOnSprite)
}//end function mdrag(mx,my)


function mtof(midival)
{	// based on expr from mtof.maxhelp :
	return (440. * Math.exp( .057762265 * (midival - 69.) )); 
}




function mu(mx,my)
{
	if (mdOnSprite)
	{
		sprite[thisSprite].color = rgb1;

		// re-pos to edge of display if dragged out of view
		sprite[thisSprite].position = [
			Math.max( -1.5, sprite[thisSprite].position[0] ),
			Math.min( 1., 
				Math.max(-1,sprite[thisSprite].position[1]) )];

		// // // // // // // // // // // // // // // // // 
		// when moving the 'position sprite' 
		//  the 'radius sprite' may be pushed out of view;
		//  if this happens then we must re-pos 'radius sprite'
		//  to the other side of 'position sprite' . . .
		if (thisSprite == 0)
		{
			// check X
			if (sprite[1].position[0] < -1.5)
			{
				calcRadVal();
				sprite[1].position = [
					sprite[0].position[0] + radiusVal,
					sprite[1].position[1] ];
			}//end if off left
			if (sprite[1].position[0] > 0.5)
			{
				calcRadVal();
				sprite[1].position = [
					sprite[0].position[0] - radiusVal,
					sprite[1].position[1] ];
			}//end if off right
			
			//check Y
			if (sprite[1].position[1] < -1.)
			{	
				calcRadVal();
				sprite[1].position = [
					sprite[1].position[0],
					sprite[0].position[1] + radiusVal ];
			}//end if off bottom
			if (sprite[1].position[1] > 1.)
			{	
				calcRadVal();
				sprite[1].position = [
					sprite[1].position[0],
					sprite[0].position[1] - radiusVal ];
			}//end if off top
			
		}//end if (thisSprite == 0)
		else if(thisSprite>1)
		{ spiroidOverlay.enable = 0; }
	}//end if (mdOnSprite)
	
	jsG.bttnDownInMainArea = false;
	
}//end function mu(mx,my)

function relativeRadiusOfSprite(id)
{ 
	tempX = sprite[0].position[0] - sprite[id].position[0];
	tempY = sprite[0].position[1] - sprite[id].position[1];
	return ( Math.sqrt((tempX*tempX)+(tempY*tempY)) );
}//end function calcRadVal()
